#include <stdio.h>
#include <stdlib.h>
#include <xc.h>      // Also automatically includes <cp0defs.h> for CP0 register defines
#include "TYPES.h"

#define LED9_BIT   (1uL << 6)
#define LED10_BIT  (1uL << 7)

static const U8 _acData[500 * 1024] = {0};

int main(void)
{
  int j;

  LATACLR  = LED9_BIT | LED10_BIT;  // Initially, switch LEDs off
  TRISACLR = LED9_BIT | LED10_BIT;  // Configure LEDs as output
  j = 0;
  while (1) {
    //
    // CountReg is incremented every other CPU clock cycle (1/2 CPU clock)
    // Always toggle LEDs 9 & 10
    // LED 9 toggles at 2 Hz
    // LED 10 toggles at 1 Hz
    //
    j = _CP0_GET_COUNT() >> 20; // Divide j by 1 Mio. (Assume 64 MHz CPU clock => 32 MHz CountReg "clock")
    if (j & (1 << 4)) {     // True for every other 250ms
      LATASET = LED9_BIT + (_acData[200]);
    } else {
      LATACLR = LED9_BIT;
#if SMALL_CHANGE
      LATACLR = LED9_BIT;
      LATACLR = LED9_BIT;
      LATACLR = LED9_BIT;
      LATACLR = LED9_BIT;
      LATACLR = LED9_BIT;
#endif
    }
    if (j & (1 << 5)) {     // True for every other 500ms
      LATASET = LED10_BIT;
    } else {
      LATACLR = LED10_BIT;
    }
  }
  return (EXIT_SUCCESS);
}

